/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "combos.h"
#include "malloc.h"
/* combo tree :

s1 - ts1 {t1_2:_TY} -> s2:"y" - ts2 {t2_3:_TX} -> s3:"yx" 
         {t1_4:_TX} -> s4:"x" - ts4 {t4_5:_TY} -> s5:"xy"

*/

/*STATE s1,s2,s3,s4,s5;
TRANSITION t1_2,t2_3,t1_4,t4_5;
TRANSITION *ts1[] = {&t1_2,&t1_4};
TRANSITION *ts2[] = {&t2_3};
TRANSITION *ts4[] = {&t4_5};
*/

// creates the tree for the state machine, starting at <root>
void build_combo_tree(STATE** root){

  STATE *s1,*s2,*s3,*s4,*s5;
  TRANSITION *t1_2,*t2_3,*t1_4,*t4_5;
  TRANSITION **ts1;
  TRANSITION **ts2;
  TRANSITION **ts4;

  s1 = malloc(sizeof(STATE));
  s2 = malloc(sizeof(STATE));
  s3 = malloc(sizeof(STATE));
  s4 = malloc(sizeof(STATE));
  s5 = malloc(sizeof(STATE));

  t1_2 = malloc(sizeof(TRANSITION));
  t2_3 = malloc(sizeof(TRANSITION));
  t1_4 = malloc(sizeof(TRANSITION));
  t4_5 = malloc(sizeof(TRANSITION));

  ts1 = malloc(2*sizeof(TRANSITION*));
  ts2 = malloc(sizeof(TRANSITION*));
  ts4 = malloc(sizeof(TRANSITION*));
 
  state_define(s1,start,1);
  state_define(s2,y,20);
  state_define(s3,yx,1);
  state_define(s4,x,20);
  state_define(s5,xy,1);
  
  transition_define(t1_2,PER_DGT_KL,s2);
  transition_define(t2_3,PER_DGT_KR,s3);
  transition_define(t1_4,PER_DGT_KR,s4);
  transition_define(t4_5,PER_DGT_KL,s5);
  
  ts1[0] = t1_2; ts1[1] = t1_4;
  ts2[0] = t2_3;
  ts4[0] = t4_5;
  
  state_set_transitions(s1,ts1,2);
  state_set_transitions(s2,ts2,1);
  state_set_transitions(s4,ts4,1);

  (*root) = s1;
}

