/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "gameobj.h"
#include "spritesdef.h"
#include "screen.h"

extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern SPR_ATTR attr[];

/*
 ************** GAME OBJECTS
 */

/*
 * BONUSES PROBS
 */

E_BONUS bonus_proba[bc_power+1][BONUS_PROBA_SIZE] = {
  {proat,proat,proat,proat,proat,
   chomplet,chomplet,throther,throther,kansas,
   kansas,liste_des_fuckings,liste_des_fuckings,jumbo_jim,long_drink},// bc_normal
  {proat,proat,proat,proat,proat,
   proat,proat,proat,proat,throther,
   throther,throther,throther,throther,throther},// bc_xaporu 
  {proat,proat,proat,kingkong,nosferatu,
   chomplet,chomplet,throther,throther,kansas,
   kansas,jumbo_jim,jumbo_jim,long_drink,long_drink},// bc_blake
  {proat,proat,proat,proat,proat,
   proat,proat,proat,proat,proat,
   nosferatu,nosferatu,chomplet,chomplet,chomplet},// bc_balibali 
  {kansas,kansas,kansas,kansas,kansas,
   kansas,kansas,kansas,kansas,kansas,
   kansas,kansas,kansas,kansas,kansas},// bc_lubion 
  {proat,proat,proat,proat,proat,
   proat,proat,proat,proat,proat,
   jumbo_jim,jumbo_jim,jumbo_jim,jumbo_jim,jumbo_jim},// bc_glarpi
  {proat,proat,proat,kingkong,nosferatu,
   chomplet,chomplet,throther,throther,kansas,
   kansas,liste_des_fuckings,liste_des_fuckings,jumbo_jim,long_drink}// bc_power
};

E_BONUS bonus_proba_get(BONUS_COLLECTION bc, int cell){
  E_BONUS resu;
  resu = bonus_proba[bc][cell];
  return resu;
}

/*
 * EXCHANGE
 */

void init_exchange_resu(EXCHANGE_RESULT* e, FIXED next_distrib){
  e->losing_team = -1;
  e->next_distrib = next_distrib;
}

/*
 * NET
 */

void net_init(NET* n, FIXED posX){
  n->pos[X] = posX;
  n->pos[Y] = POS_BOTTOM-toFIXED(16.0);
  n->pos[Z] = toFIXED(169.0);
  n->pos[S] = toFIXED(1.0);
}

void net_display(NET* n){
  FIXED pos[XYZS];
  ANGLE ang = DEGtoANG(0.0);
  int spr_top = FIRST_NET_SPR;
  int spr_bottom = FIRST_NET_SPR+1;

  pos[X] = n->pos[X];
  pos[Y] = n->pos[Y];
  pos[Z] = n->pos[Z];
  pos[S] = n->pos[S];

  slDispSprite(pos, (SPR_ATTR *)(&attr[spr_bottom].texno), ang);   

  pos[Y] = pos[Y] - toFIXED(32.0);
  slDispSprite(pos, (SPR_ATTR *)(&attr[spr_top].texno), ang);    
}

// net is a net array
int net_get_team_from_x(NET* net, int n_net, FIXED x){
  int c_net = -1;
  int found = FALSE;
  FIXED net_dist = net[0].pos[X]-POS_LEFT;
 
  do {
    c_net++;
    int xr = net[c_net].pos[X];
    int xl = xr - net_dist;
    found = ((xl<=x) && (x<=xr));
  } while ((c_net<n_net)&&(!found));
    
  return c_net;
}


/*
 * TEAM
 */

void team_init(TEAM* t) {
  t->points = 0;
}

/*
 * PLAYER OPTIONS
 */

void player_options_init(PLAYER_OPTIONS* pop){
  int i,j;

  pop->go_trough_net = TRUE;
  for (i=0;i<MAX_BONUS_NB;i++){
    pop->queue[i] = no_bonus;
    for (j=0;j<XYZS;j++){
      pop->pos[i][j] = toFIXED(0.0);
    }
  }
}

// returns FALSE if queue full, else TRUE
int player_options_queue(PLAYER_OPTIONS* op, E_BONUS type,int max_bonus_nb){
  int rank=0;
  int full = TRUE;

  // find first free slot
  while ((rank<MAX_BONUS_NB)&&((op->queue[rank])!=no_bonus)){
    rank++;
  }
  if ((rank<max_bonus_nb)&&(rank<MAX_BONUS_NB)){
    // add
    full=FALSE;
    op->queue[rank] = type;
    op->pos[rank][X] = toFIXED(0.0);
    op->pos[rank][Y] = toFIXED(-100.0);
    op->pos[rank][Z] = toFIXED(169.0);
    op->pos[rank][S] = toFIXED(1.0);
  }
  return full;
}

E_BONUS player_options_get_type(PLAYER_OPTIONS* op){
  E_BONUS resu;
  resu = op->queue[0];
  return (resu);
}

E_BONUS player_options_pop(PLAYER_OPTIONS* op){
  E_BONUS resu;
  int i;
  // get first in
  resu = op->queue[0];
  // reorder
  for (i=0;i<(MAX_BONUS_NB-1);i++){
    op->queue[i] = op->queue[i+1];
    op->pos[i][X] =  op->pos[i+1][X];
    op->pos[i][Y] =  op->pos[i+1][Y];
    op->pos[i][Z] =  op->pos[i+1][Z];
    op->pos[i][S] =  op->pos[i+1][S];
  }
  // fix last
  op->queue[MAX_BONUS_NB-1] = no_bonus;
  return resu;
}

void player_options_move(PLAYER_OPTIONS* op, FIXED *target){ 
  int rank=0;
  FIXED f = toFIXED(4.0); // rattrape 1/20 le premier, 1/(20+10)
  FIXED g = toFIXED(0.0);
  
  while ((rank<MAX_BONUS_NB)&&((op->queue[rank])!=no_bonus)){
    FIXED xbo,ybo;
    FIXED rt[XY]; // real target
 
    xbo = op->pos[rank][X]; 
    ybo = op->pos[rank][Y]; 
    if (rank == 0) {
      ybo -= toFIXED(10.0);
    } else {
      ybo += toFIXED(1.0);
    }

    rt[X] = target[X] + g;
    rt[Y] = target[Y] ;//- toFIXED(10.0);

    op->pos[rank][X] = xbo + slDivFX(f,(rt[X]-xbo));
    op->pos[rank][Y] = ybo + slDivFX(f,(rt[Y]-ybo));
    
    f += toFIXED(5.0);

    g = (g==toFIXED(0.0))?toFIXED(6.0):slMulFX(toFIXED(-1.5),g);

    rank++;
  }
}

void display_bonus_sprite(FIXED* pos, ANGLE ang, E_BONUS type){
  int spr_num =-1;
  
  switch (type){
  case no_bonus : spr_num = FIRST_BONUS_SPR; break;
  case proat : spr_num = FIRST_BONUS_SPR+1; break;
  case kingkong :  spr_num =  FIRST_BONUS_SPR+2; break;
  case nosferatu : spr_num =  FIRST_BONUS_SPR+3; break;
  case throther : spr_num =  FIRST_BONUS_SPR+4; break;
  case kansas : spr_num =  FIRST_BONUS_SPR+5; break;
  case liste_des_fuckings: spr_num =  FIRST_BONUS_SPR+6; break;
  case jumbo_jim: spr_num =  FIRST_BONUS_SPR+7; break;
  case chomplet: spr_num =  FIRST_BONUS_SPR+8; break;
  case long_drink: spr_num =  FIRST_BONUS_SPR+9; break;
  default:  spr_num =  FIRST_BONUS_SPR; 
    break;
  }
  if (spr_num!=-1)
    slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num].texno), ang);       
}

void player_options_display(PLAYER_OPTIONS* op){
  int rank=0;
  FIXED ang=DEGtoANG(0.0);

  while ((rank<MAX_BONUS_NB)&&((op->queue[rank])!=no_bonus)){
    display_bonus_sprite(op->pos[rank], ang, op->queue[rank]);
    rank++;
  }
}

/*
 * GAME_OPTIONS
 */

void game_options_init(GAME_OPTIONS* gop){
  gop->instant_match = FALSE;
  gop->is_on[floupix] = TRUE;
  gop->is_on[kingkong] = TRUE;
  gop->is_on[throther] = TRUE;
  gop->is_on[kansas] = TRUE;
  gop->is_on[little_kansas] = TRUE;
  gop->is_on[nosferatu] = TRUE;
  gop->is_on[proat] = TRUE;
  gop->is_on[liste_des_fuckings] = TRUE;
  gop->is_on[side_kick] = TRUE;
  gop->is_on[jumbo_jim] = TRUE;
  gop->distrib = smooth;
  gop->control_set = cs_combo;
  gop->game_lenght = gl_medium;
  gop->bonus_collection = bc_power;
  gop->cd_music = cdmusic_on;
}

int  game_options_get_max_point(GAME_OPTIONS* gop){
  int max_point;
  switch (gop->game_lenght) {
  case gl_flash     : max_point = 5; break ;
  case gl_short     : max_point = 10;  break;
  case gl_long      : max_point = 30; break;
  case gl_very_long : max_point = 50; break;
  case gl_endless   : max_point = 100; break;
  case gl_sysiphe   : max_point = 2400; break;
    //case gl_sysiphe   : max_point = 3; break;
  case gl_medium    : 
  default:
    max_point = 20; 
  }
  return max_point;
}

/*
 * PLAYER
 */

void player_init(PLAYER* p, int pad_num, FIXED* pos,  FIXED mass, int team, int sprite){
  p->pad_num = pad_num;
  p->pos[X] = pos[X]; p->pos[Y] = pos[Y];
  p->mass = mass;
  p->team = team;
  p->sprite = sprite;
  player_reinit(p);
  player_options_init(&(p->options));
}

void player_reinit(PLAYER* p){
  p->pos[Z] = toFIXED(169.0);
  p->pos[S] = toFIXED(1.0);
  p->speed[X]=toFIXED(0.0);
  p->speed[Y]=toFIXED(0.0); 
  p->speed[Z]=toFIXED(0.0);
  p->last_pos[X] = p->pos[X];
  p->last_pos[Y] = p->pos[Y];
  p->gaz_counter = -1;
  player_options_init(&(p->options));
}

#define MAX_GAZ 10 //(LAST_GAZ_SPR-FIRST_GAZ_SPR) // for display only

void player_display(PLAYER* p){
  FIXED pos [XYZS];
  int i;
  ANGLE ang = DEGtoANG(0.0);
  int spr_num = p->sprite;
  
  for (i=0;i<XYZS;i++) pos[i] = p->pos[i];
  pos[Y] -=  (toFIXED(16.0) + PLAYER_SPR_CENTER_OFFSET);

  slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num].texno), ang);   

  /*
  if (p->gaz_counter>0){
    pos[Y] += toFIXED(24.0);
    spr_num =  FIRST_GAZ_SPR + p->gaz_counter;//+ (LAST_GAZ_SPRITE-FIRST_GAZ_SPR);  // LAST_GAZ_SPR

    slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num].texno), ang);   
    (p->gaz_counter)--;
  }
  */
  if (p->gaz_counter>0){
    pos[Y] += toFIXED(24.0);
    spr_num =  FIRST_GAZ_SPR + ((p->gaz_counter)%(LAST_GAZ_SPR-FIRST_GAZ_SPR));
    slDispSprite(pos, (SPR_ATTR *)(&attr[spr_num].texno), ang);   
    (p->gaz_counter)--;
  }
}

void player_give_gaz(PLAYER* p){
  p->gaz_counter = MAX_GAZ;
}

/*
 * BALL
 */



void ball_init(BALL* b,FIXED* pos, FIXED* speed, FIXED mass){
  int i;
  for (i=0;i<XY;i++) b->pos[i] = pos[i];
  b->pos[Z] = toFIXED(169.0);
  b->pos[S] = toFIXED(1.0);
  for (i=0;i<XYZ;i++) b->speed[i] = speed[i];
  b->mass = mass;
  b->last_pos[X] = b->pos[X];
  b->last_pos[Y] = b->pos[Y];
}

void ball_display(BALL* b){
  static   ANGLE ang = DEGtoANG(0.0);
  int spr_num = FIRST_BALL_SPR;

  slDispSprite(b->pos, (SPR_ATTR *)(&attr[spr_num].texno), ang);   
}

void ball_dbg_display_speed(BALL* b,int x, int y){
  FIXED ss = slSquartFX(slMulFX(b->speed[X],b->speed[X])+slMulFX(b->speed[Y],b->speed[Y]));

  slPrintFX(b->speed[X],slLocate(x,y));
  slPrintFX(b->speed[Y],slLocate(x,y+1));
  slPrintFX(ss,slLocate(x,y+2));
}


/*
 * GAME
 */ 

void game_init(GAME* g, TEAM *team, int n_team, PLAYER *player, int n_player, CIPIU *cipiu, int n_cipiu, NET *net, int n_net, GAME_OPTIONS* ga_options){
  g->n_team = n_team;
  g->team = team;
  g->player = player ;
  g->n_player = n_player;
  g->cipiu = cipiu;
  g->n_cipiu = n_cipiu;
  g->net = net;
  g->n_net = n_net;
  player_options_init(&(g->pl_options));
  g->ga_options = ga_options;   
}

