/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



/*
  TODO
 -> ?? different player different mass 
 -> ?? different action (impacts apply_gravity)
 -> ?? different speedY (inpacts _TU in sub_exchange)
 -> bug du filet
 -> s'assoir sur le filet
 -> probleme avec les player_option dans le game (redondant) 
 -> grosse balle dans un bous
 -> bonus qui repousse (et tous les boni manquants)
 -> son avec le midi direct
 -> routine de selection alatoire du fond d'cran (int).
*/

#include    "sl_def.h"
#include    "sgl.h"
#include    "scrltxt.h"
#include    "libpad.h"
#include    "physics.h"
#include    "gameobj.h"
#include    "spritesdef.h"
#include    "screen.h"
#include    "combos.h"    
#include    "malloc.h" 
#include    "pic_view/gfxconst.h" // background
#include    "pic_view/vbt_file.h" // cd file loading
#include    "pic_view/vbt_gfx.h" // cd file loading
#include    "options.h"
#include    "fldefs.h"
#include    "sound.h"        
#include    "persist.h"      // backup lib
#include    "cipiu.h"        // ia
#include    "help.h"         //  help_screens
#include    "fl_pict.h"      // background pictures
#include    "fl_cdda.h"      // cd music.


/**/

//extern void InitCD();
extern Uint32   _bstart, _bend;

unsigned short file_id,dir_id;
float iVertical,iHorizontal,iZoom;
Uint8 bShowMenu;


FL_PICTURE pic; // background picture

/*
 */
#define TRUE  (0==0)
#define FALSE (0!=0)


/*
 * PAD
 */

extern int p_pad[]; // physical pad number


/*
 * SPRITES
 */ 

extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern SPR_ATTR attr[];
static void set_sprite(PICTURE *pcptr , Uint32 NbPicture)
{
  TEXTURE *txptr;

  for(; NbPicture-- > 0; pcptr++){
    txptr = tex_spr + pcptr->texno;
    slDMACopy((void *)pcptr->pcsrc,
	      (void *)(SpriteVRAM + ((txptr->CGadr) << 3)),
	      (Uint32)((txptr->Hsize * txptr->Vsize * 4) >> (pcptr->cmode)));
  }
}


/* 
 * RANDOM FUNCTIONS
 */

FIXED minmaxrnd(FIXED min, FIXED max){
  FIXED resu,mmax,mmin;
  mmax = (max>min)?max:min;
  mmin = (max>min)?min:max;
  resu = min + slMulFX(slRandom(),max-min);
  return resu;
}

int minmaxrndint(int min,int max){
   int a = (int)(slRandom());
   a = (a&(~0x8000));
   a = min + (a%(max-min+1));
   return (a);
}


/*
 * SUPERB FUNCTION
 */
void clear_screen(){
  int i,j;
  for (i=0;i<50;i++){
    for (j=0;j<50;j++){
      slPrint(" ",slLocate(i,j));
    }
  }
}




/*
 *        TITLE SCREEN (GAME TYPE CHOICE)
 */

void display_title_sprite_anim(int die){
  static FIXED pos[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(169.0),toFIXED(1.0)};
  static FIXED speed[] = {toFIXED(0.0),toFIXED(0.0)};
  static ANGLE ang = DEGtoANG(0.0);
  static FIXED count = toFIXED(-1.0);
  static int zoom_out = TRUE;
  //  static FIXED b_pos[5][XYZS];
  int i;

  if (count < toFIXED(0.0)){ // new speed
    count = minmaxrnd(toFIXED(50.0),toFIXED(200.0));
    speed[X] = minmaxrnd(toFIXED(20.0),toFIXED(20.0));
    speed[Y] = minmaxrnd(toFIXED(20.0),toFIXED(20.0));  
    ang = 0x1000;
    zoom_out = !zoom_out;
  } else {
    count -= toFIXED(1.0);
    if (ang != 0x0) ang += 0x0800;
  }
    
    
  // light speed modification
  speed[X] += minmaxrnd(toFIXED(-0.02),toFIXED(0.02));
  speed[Y] += minmaxrnd(toFIXED(-0.02),toFIXED(0.02));
    
  // slows down near center
  speed[X] -= slMulFX(pos[X],toFIXED(0.01));
  speed[Y] -= slMulFX(pos[Y]+toFIXED(30.0),toFIXED(0.15));
    
  if (!die){
    if (zoom_out) {
      if (pos[X]>0) {
	pos[S] = slDivFX(toFIXED(60.0),pos[X]);
      } else {
	pos[S] = slDivFX(toFIXED(-60.0),pos[X]);
      }
    } else {
      if (pos[X]>0) {
	pos[S] = toFIXED(1.0) -slDivFX(toFIXED(100.0),pos[X]);
      } else {
	pos[S] =  toFIXED(1.0) - slDivFX(toFIXED(-100.0),pos[X]);
     }   
    }
  } else {
    pos[S] = slMulFX(toFIXED(1.07),pos[S]);
  }


  // hard boucing on screen border
  if (pos[X]>POS_RIGHT) {
    pos[X] = POS_RIGHT;
    speed[X] = slMulFX(speed[X],toFIXED(-1.01));
  }
  if (pos[X]<POS_LEFT) {
    pos[X] = POS_LEFT;
    speed[X] = slMulFX(speed[X],toFIXED(-1.01));
  }
  if (pos[Y]>(POS_BOTTOM-toFIXED(80.0))) {
    pos[Y] = POS_BOTTOM-toFIXED(80.0);
    speed[Y] = slMulFX(speed[Y],toFIXED(-1.01));
  }
  if (pos[Y]<POS_TOP) {
    pos[Y] = POS_TOP;
    speed[Y] = slMulFX(speed[Y],toFIXED(-1.01));
  }
    
    
  if (speed[X] > toFIXED(6.0)) speed[X] = toFIXED(6.0);
  if (speed[X] < toFIXED(-6.0)) speed[X] = toFIXED(-6.0);
  if (speed[Y] > toFIXED(6.0)) speed[Y] = toFIXED(6.0);
  if (speed[Y] < toFIXED(-6.0)) speed[Y] = toFIXED(-6.0);
    
  // apply accel
  pos[X] += speed[X];
  pos[Y] += speed[Y];
    
  // display title
  slDispSprite(pos, (SPR_ATTR *)(&attr[TITLE_SPR].texno), ang);   
    
  // display ssmtf
    
  FIXED ss_pos[XYZS];
    
  for (i=2;i<4;i++){
    ss_pos[i] = pos[i];
  }
  ss_pos[S] = slDivFX(toFIXED(3.0),pos[S]);
  ss_pos[X] = slDivFX(toFIXED(10.0),pos[X]) - toFIXED(130.0);
  ss_pos[Y] = slMulFX(toFIXED(2.0),pos[Y]);
    
  slDispSprite(ss_pos, (SPR_ATTR *)(&attr[SSMTF_SPR].texno), ang);     
    
  // display ball & stars

  /*  for (i=0;i<5;i++){
    b_pos[i][X] = minmaxrnd(toFIXED(-40.0),toFIXED(40.0));
    b_pos[i][Y] = minmaxrnd(toFIXED(-40.0),toFIXED(20.0));
    b_pos[i][Z] = toFIXED(170.0);
    b_pos[i][S] = minmaxrnd(toFIXED(0.0),toFIXED(3.0)); //slMulFX(toFIXED(1.04),b_pos[i][S]);
    slDispSprite(b_pos[i], (SPR_ATTR *)(&attr[FIRST_BALL_SPR+1].texno), DEGtoANG(0.0));  
  } 
  */
}
  
void sub_options_menu(GAME_OPTIONS* ga_options,OPTIONS_MENU* om){

  // set menu from options values !! values order !!
  om->value[0] = ga_options->control_set;  // controls
  om->value[1] = ga_options->distrib;      // bonus distribution
  om->value[2] = ga_options->game_lenght;  // game_lenght
  om->value[3] = ga_options->bonus_collection; // bonus collection
  om->value[4] = ga_options->cd_music; // music on or off

  // set options with menu
  options_menu_activate(om);

  // set options from menu values
  ga_options->control_set=  om->value[0];
  ga_options->distrib    =  om->value[1];
  ga_options->game_lenght = om->value[2];
  ga_options->bonus_collection = om->value[3];
  ga_options->cd_music = om->value[4];

  persist_set(ga_options);
}

void display_game_selection_text(int on){
  if (on) {
    slPrint("     * Game Selection *      ",slLocate(4,20));
    slPrint("  Y  :  one net, two teams   ",slLocate(4,23));
    slPrint("  Z  :  two nets, three teams",slLocate(4,24));
    slPrint("       [C : options  ]       ",slLocate(4,26));
    slPrint("       [X : reference]       ",slLocate(4,27));
    //    slPrint("       [R : rules    ]       ",slLocate(4,28));
  } else {
    slPrint("                             ",slLocate(4 ,20));
    slPrint("                             ",slLocate(4 ,23));
    slPrint("                             ",slLocate(4 ,24));
    slPrint("                             ",slLocate(4 ,26));
    slPrint("                             ",slLocate(4 ,27));
    slPrint("                             ",slLocate(4 ,28));
  }
}

void sub_help(){
  /*
    help_display();
    fl_picture_display(&pic);
  */
}

void sub_instant_help(){
  fl_picture_load_and_forget(HELP_SLIDE_IN_GAME);
  while (! (  pad_someone_presses(PER_DGT_TR,1) || pad_someone_presses(PER_DGT_ST,0))){
    slSynch();
  }
  fl_picture_display(&pic);
}

// future players choose the number of teams
int sub_ask_for_team_number_and_options(GAME_OPTIONS* ga_options, OPTIONS_MENU* om){
  int i;
  int number = 0;
  
  // print
  display_game_selection_text(TRUE);
  // choose Y->2 Z->3
  while (number == 0){
    Sint16 padp;
    Sint16 padd;

    for (i=0;i<MAX_PAD_NB;i++){
      padp = ~(Smpc_Peripheral[p_pad[i]].push);
      padd = ~(Smpc_Peripheral[p_pad[i]].data);

      //      if (padp & PER_DGT_TB)        midize();

      
      if (padp & PER_DGT_TC){ // options menu
	//display_game_selection_text(FALSE);
	clear_screen();
	sound_play(snd_bing);
	sub_options_menu(ga_options,om);
	clear_screen();
	sound_play(snd_bing);
	display_game_selection_text(TRUE);
      }

      /*
	if (padp & PER_DGT_TR){ // help 
	//display_game_selection_text(FALSE);
	clear_screen();
	sound_play(snd_bing);
	sub_help();
	clear_screen();
	sound_play(snd_bing);
	display_game_selection_text(TRUE);
      }
      */

      if (padp & PER_DGT_TX){ // instant help
	//display_game_selection_text(FALSE);
	clear_screen();
	sound_play(snd_bing);
	sub_instant_help();
	clear_screen();
	sound_play(snd_bing);
	display_game_selection_text(TRUE);
      }

      if (padp & PER_DGT_TY) { // team nb selection
	number = 2;
      } else {
	if (padp & PER_DGT_TZ) {
	  number = 3;
	}
      }
    }
    display_title_sprite_anim(FALSE);
    slSynch();
  }
  
  for (i=0;i<50;i++){
    int die = TRUE;
    display_title_sprite_anim(die);
    slSynch();
  }
   
  // clean
  display_game_selection_text(FALSE);
  
  return number;
}

/*
 *       PLAYER REGISTRATION
 */

// find a the next  sprite that is not used by any
// player starting from sprite <fs>. returns sprite num, 
// -1 if not found
int find_next_unused_pl_sprite(PLAYER* player, int n_players, int fs){

  int i;
  int is_free_sprite = FALSE;
  int new_spr,cur_spr;

  new_spr = -1;
  cur_spr = fs;

  while ((!is_free_sprite)&&(!(cur_spr == (fs-1)))){

    is_free_sprite = TRUE;

    // already in use by any other player ?
    for (i=0;i<n_players;i++){ 
      is_free_sprite = (is_free_sprite && (player[i].sprite != cur_spr));
    }

    if (is_free_sprite) 
      new_spr = cur_spr;

    if ((++cur_spr)>LAST_PLAYER_SPR) 
      cur_spr = FIRST_PLAYER_SPR;
  }

  return new_spr;
}


FIXED give_random_x_by_team_nb(int c_team, int n_teams){
  FIXED size,x;
  size = slDivFX(toFIXED((n_teams)*1.0),(POS_RIGHT-POS_LEFT));
  x = PLAYER_SPR_RADIUS+POS_LEFT+slMulFX(toFIXED(1.0*c_team),size)
    +minmaxrnd(toFIXED(0.0),size-PLAYER_SPR_RADIUS-PLAYER_SPR_RADIUS);
  return x;
}


void player_team_choice_text(int display,int x,int y){
  if (display == TRUE) {
    slPrint("                                        ",slLocate(x,y++)) ;
    slPrint("      <A>    to join/select floupix     ",slLocate(x,y++)) ;
    slPrint("      <B>    to select a team           ",slLocate(x,y++)) ;
    slPrint("      <C>    to become a cipiu          ",slLocate(x,y++)) ;
    slPrint("    <START>  to start                   ",slLocate(x,y++)) ;
    slPrint("                                        ",slLocate(x,y++)) ;
  } else {
    slPrint("                                         ",slLocate(x,y++)) ;
    slPrint("                                         ",slLocate(x,y++)) ;
    slPrint("                                         ",slLocate(x,y++)) ;
    slPrint("                                         ",slLocate(x,y++)) ;
    slPrint("                                         ",slLocate(x,y++)) ;
    slPrint("                                         ",slLocate(x,y++)) ;
  }
}

// players tell they wants to play by choosing their team
// the <player> array is filled with players <cipiu>, with *n_cipiu cipius
// returns number of players.

int sub_players_team_choice(int n_teams, PLAYER* player,NET* net, CIPIU* cipiu,int* pn_cipiu ){

  int c_team = 0;
  int n_players = 0; 
  int start = FALSE;
  int i,j;
  int n_cipiu = 0; 

  int txtpos[XY];
  
  // reset players
  for (j=0;j<MAX_PLAYER_NB;j++){
    player[j].pad_num = -1;
  }

  // displays help text coming from bottom right 
  txtpos[X] = minmaxrndint(30,60);
  txtpos[Y] = minmaxrndint(35,60);
  player_team_choice_text(TRUE,txtpos[X],txtpos[Y]);

  while (!start) {

    if ((txtpos[X]!=0)||(txtpos[Y]!=0)) {
      player_team_choice_text(FALSE,txtpos[X],txtpos[Y]);
      txtpos[X] += (txtpos[X]>0)?-1:0;
      txtpos[Y] += (txtpos[Y]>2)?-1:0;
      player_team_choice_text(TRUE,txtpos[X],txtpos[Y]);
      //      slSynch();  
    }

    for (i=0;i<MAX_PAD_NB;i++){
      Uint32 padp;
      padp = ~(Smpc_Peripheral[p_pad[i]].push);
      int exists = FALSE;
      int cur_player = -1;

      // <exists> is : the the pad is already affected (to <cur_player>)
      int j = 0;
      while ((j<n_players) && (!exists)){
	if (player[j].pad_num == p_pad[i]){
	  exists = TRUE;
	  cur_player = j;
	}	
	j++;
      }

      // start game ?
      if (padp & PER_DGT_ST) {
	if (n_players >= 1/*n_teams*/) {
	  start = TRUE;
	}
      }

      // change team
      if (padp & PER_DGT_TB){
	if (exists){
	  int nt;
	  nt = player[cur_player].team;
	  c_team = nt;
	  nt++;
	  if (nt>=n_teams) nt=0;
	  player[cur_player].team = nt;
	  player[cur_player].pos[X] = give_random_x_by_team_nb(nt,n_teams);
	  sound_play(snd_bad);
	}
      }

      // add player or change sprite ?
      if ((padp & PER_DGT_TA)||(padp & PER_DGT_TC)) {

	// if already exists, <A> means he wants to change his sprite 
	// <C> he want to transform itselfs into a cipiu
	if (exists){
	  if (padp & PER_DGT_TA){
	    // change color
	    int spr = 0;
	    spr = find_next_unused_pl_sprite(player,n_players,player[cur_player].sprite);
	    player[cur_player].sprite = spr;
	    sound_play(snd_bing);
	  } else if (padp & PER_DGT_TC){
	    // transform into a cipiu
	    player[cur_player].pad_num = IS_CIPIU;
	    cipiu_init(&cipiu[n_cipiu],&player[cur_player]);
	    n_cipiu++;
	    sound_play(snd_death);
	  }
	}

	if ((!exists) && (padp & PER_DGT_TA)){   // OR non existing player presses A to join

	  int no_more_slots = (n_players>=MAX_PLAYER_NB);
	  if (!no_more_slots){
	    // create player	    
	    FIXED pos[XYZS];
	    int pl_pad;

	    pos[X] = give_random_x_by_team_nb(c_team,n_teams);
	    pos[Y] = minmaxrnd(toFIXED(-40.0),toFIXED(40.0)); 
	    FIXED mass = MASS_PLAYER;
	    int spr = find_next_unused_pl_sprite(player,n_players,FIRST_PLAYER_SPR);
	    if (spr == -1) spr = FIRST_PLAYER_SPR; //hum...
	    // init_player
	    pl_pad = p_pad[i];
	    player_init(&player[n_players],pl_pad,  pos, mass, c_team, spr);

	    player[n_players].speed[X] = minmaxrnd(toFIXED(-5.0),toFIXED(5.0));
	    player[n_players].speed[Y] = minmaxrnd(toFIXED(-1.0),toFIXED(5.0));
	
	    n_players++;
	    c_team++;
	    sound_play(snd_birth);
	    if (c_team>=n_teams) c_team = 0;
	  } else {
	    // no more slots : nothing happens
	  }
	}
      }
    }
    
    //       scrollTxtSchedule();    
    //       scrollTxtDisplay();
    
    // display
    
    for (i=0;i<n_players;i++)     player_display(&player[i]);
    for (i=0;i<(n_teams-1);i++)   net_display(&net[i]);   
    
    slSynch();
  }

  player_team_choice_text(FALSE,txtpos[X],txtpos[Y]);

  // modify cipiu nb
  (*pn_cipiu) = n_cipiu; 

  return n_players;
}

/*
 *       EXCHANGE
 */

// TODO : doc
void compute_boucing_ball_speed(BALL* b, PLAYER* p){

  // is fact, there is no collision...
  if (b->pos[Y]>(p->pos[Y]-PLAYER_SPR_CENTER_OFFSET))
    return;

  FIXED dist1,dist2;
  dist1 = (p->last_pos[Y] - PLAYER_SPR_CENTER_OFFSET) - b->last_pos[Y];
  dist2 = (p->pos[Y] - PLAYER_SPR_CENTER_OFFSET) - b->pos[Y];
  
  if (dist1 < dist2){ // the boucing surf. is flat
    //    scrollTxtAddTxtLine("coll bas ");
    FIXED sy =  b->speed[Y];
    b->speed[Y] = slSquartFX(slMulFX(sy,sy));
  } else { // else, it is curved ...
    //    scrollTxtAddTxtLine("haut ");
    
    FIXED x_p,y_p,x_b,y_b; // ball & player position
    FIXED dx, dy;          
    FIXED d,d_2;           // distancy & distancy^2
    FIXED vx, vy;          // ball speed
    FIXED vxdx,vxdy,vydx,vydy,dx_d2,dy_d2; // various terms ...
    
    vx = b->speed[X];  
    vy = b->speed[Y];   
    
    x_b=b->pos[X];  
    y_b=b->pos[Y];
    
    x_p=p->pos[X];  
    y_p=p->pos[Y];
    
    dx = x_p - x_b;
    dy = (y_p - y_b);   
    d_2 = slMulFX(dx,dx) + slMulFX(dy,dy);
    d  = slSquartFX(d_2);
    
    // boucing direction & speed
    vxdx = slMulFX(vx,dx);
    vxdy = slMulFX(vx,dy);
    vydx = slMulFX(vy,dx);
    vydy = slMulFX(vy,dy);
    dx_d2 = slDivFX(d_2,dx);
    dy_d2 = slDivFX(d_2,dy);
    
    b->speed[X] = slMulFX(dx_d2,vxdx-vydy) - slMulFX(dy_d2,vxdy+vydx);
    b->speed[Y] = - slMulFX(dy_d2,vydy-vxdx) + slMulFX(dx_d2,vxdy+vydx);
    
    // correct ball position (push ball to the surface)
    FIXED cos_a,sin_a;
    FIXED real_pradius = BALL_SPR_RADIUS+PLAYER_SPR_RADIUS+toFIXED(1.0);
    
    cos_a = slDivFX(d,dx);
    sin_a = slDivFX(d,dy);
    
    b->pos[X] = x_p - slMulFX(real_pradius, cos_a);
    b->pos[Y] = y_p - slMulFX(real_pradius, sin_a);
  }
 
  // ball speed modification according the player's  (in all kind of coll)
  int i;
  for (i=0;i<2;i++){
    if ((slMulFX(b->speed[i],p->speed[i])<toFIXED(0.0))){ // b and p speeds sign are opposed
      b->speed[i] += p->speed[i];
    } else { //b and p speeds sign are the same
      FIXED vp2,vb2;
      vp2 = slMulFX(p->speed[i],p->speed[i]);
      vb2 = slMulFX(b->speed[i],b->speed[i]);
      if (vb2<vp2){
	b->speed[i] += p->speed[i];
      }
    }
  }
}

void debug_world(WORLD* w) {
  static int dsply = FALSE;
  int padd = ~(Smpc_Peripheral[15].data);
  int padp = ~(Smpc_Peripheral[15].push);
  int x1 = 0;
  int x2 = 23;
  int yb = 16;
  int i = yb;
  FIXED base_offset;

  if (padp & PER_DGT_ST){
    dsply = !dsply;
  }

  if (dsply){

    // change world
    FIXED * pval = (FIXED*) NULL;   
    if (padd & PER_DGT_TA) {
      pval = &(w->gravity);
      base_offset =  toFIXED(0.001);
    } else {
      base_offset =  toFIXED(0.01);
    }

    if (padd & PER_DGT_TB) pval = &(w->ground_friction);
    if (padd & PER_DGT_TC) pval = &(w->air_friction);
    if (padd & PER_DGT_TX) pval = &(w->speed_limit);

    if (padp & PER_DGT_KU) (*pval) += base_offset;
    if (padp & PER_DGT_KD) (*pval) -= base_offset;
    if (padp & PER_DGT_KL) (*pval) -= slMulFX(base_offset,toFIXED(10.0));
    if (padp & PER_DGT_KR) (*pval) += slMulFX(base_offset,toFIXED(10.0));

   
    // display world
    slPrint("        gravity (A) : ",slLocate(x1,i));slPrintFX(w->gravity,slLocate(x2,i++));  
    slPrint("ground friction (B) : ",slLocate(x1,i));slPrintFX(w->ground_friction,slLocate(x2,i++));  
    slPrint("   air_friction (C) : ",slLocate(x1,i));slPrintFX(w->air_friction,slLocate(x2,i++));    
    slPrint("    speed_limit (X) : ",slLocate(x1,i));slPrintFX(w->speed_limit,slLocate(x2,i++));
  } else {
    slPrint("                                                   ",slLocate(x1,i++));
    slPrint("                                                   ",slLocate(x1,i++));
    slPrint("                                                   ",slLocate(x1,i++));
    slPrint("                                                   ",slLocate(x1,i++));
  }
}

void display_scores(GAME* game){
  int n_team = game->n_team;
  int max_points;
  int i,x;
  
  max_points = game_options_get_max_point(game->ga_options);

  for (i=0;i<n_team;i++){
    TEAM* t = &(game->team[i]);
    switch (n_team) {
    case 2 :
      switch (i) {
      case 0 : 	x = 8 ; break;
      case 1 :  default : x  = 22 ; break;
      }
      break;
    case 3 :
      switch (i) {
      case 0 : 	x = 7 ; break;
      case 1 :  x = 16; break;
      case 2 : default : x = 25 ; break;
      }
      break;
    default :
      x = 5;
      break;
    }
    slPrintFX(toFIXED(1.0*(t->points)),slLocate(x,1));
    slPrint("      ",slLocate(x+6,1));
    if (t->points == max_points-1) 
      slPrint(">",slLocate(x-1,1)); 
    else 
      slPrint(" ",slLocate(x-1,1)); 
  }
}




// get a random bonus num 
E_BONUS get_random_bonus(GAME_OPTIONS* ga_options){
  FIXED s = minmaxrnd(0,14);
  E_BONUS type = no_bonus;
  type = bonus_proba_get(ga_options->bonus_collection,s);
  return type;
}

// returns time remaining before next distrib
FIXED distribute_bonuses(GAME* game){
  FIXED time;
  int maxb;
  FIXED tmax,tmin;
   int i,j,nb;

   switch (game->ga_options->distrib){
   case chainsaw : 
     tmax = toFIXED(1.0); tmin = toFIXED(2.0);
     maxb = 4;
     nb = 5;
     break;
   case boumtou : 
     tmax = toFIXED(40.0); tmin = toFIXED(100.0);
     maxb = MAX_BONUS_NB;
     nb = 3;
    break; 
   case ok_corral :
    tmax = toFIXED(3.0); tmin = toFIXED(10.0);
    maxb = MAX_BONUS_NB;
    nb = 3;
    break; 
  case smooth :   
    tmax = toFIXED(40.0) ; tmin = toFIXED(100.0);
    maxb = 3;
    nb = 2;
    break; 
   case none :
     tmax = toFIXED(4000.0) ; tmin = toFIXED(9000.0);
     maxb = 3;
     nb = 0;
     break ;
  case straight:
  default:
    tmax = toFIXED(100.0) ; tmin = toFIXED(200.0);
    maxb = 2;
    nb = 1;
    break; 
  }

  for (i=0;i<nb;i++){
    for (j=0;j<(game->n_player);j++){
      E_BONUS type = get_random_bonus(game->ga_options);    
      player_options_queue(&(game->player[j].options),type,maxb);
    }  
  }

  time = minmaxrnd(tmin,tmax);

  return time;
}

// returns the num of the player wich pad_num is <pad_num>, 
// or something negative otherwise.

int get_player_by_pad_num(GAME* game,int pad_num){
  int i;
  int pl_num=-1;
  for (i=0;i<game->n_player;i++){
    if (game->player[i].pad_num == pad_num)
      pl_num = i;
  }
  return pl_num;
}

  
// players do an exchange : real game 
void sub_exchange(GAME* game, WORLD* w, EXCHANGE_RESULT* exch_ret){

  int i;
  int stop = FALSE;
  int n_team_change=0;  // how many times the ball goes from one team to another
  int pause = FALSE;
  int pauser_team = -1;
  static BALL ball[MAX_BALL_NB];
  int n_ball = 1;
  int b_proat_mode = FALSE;
  int b_nosferatu_count = -1;
  int b_kingkong_count = -1;
  int b_throther_count = -1;
  int b_liste_des_fuckings_count = -1;
  int b_jumbo_jim_count = -1;
  int b_chomplet_mode = FALSE;
  int b_long_drink_mode = FALSE;


  FIXED next_distrib = exch_ret->next_distrib;

  // init the ball(s)
  for (i=0;i<MAX_BALL_NB;i++){
    FIXED pos[XYZ];FIXED speed[XYZ];
    FIXED mass = MASS_BALL;
    BALL* b = &(ball[i]);
    //    pos[X]=minmaxrnd(POS_LEFT,POS_RIGHT);
    pos[Y]= toFIXED(-50.0);
    pos[X] = toFIXED(0.0);//game->player[0].pos[X];
    speed[X]= minmaxrnd(toFIXED(-3.0),toFIXED(3.0));
    speed[Y]= minmaxrnd(toFIXED(-3.0),toFIXED(-2.0));
    speed[Z]= toFIXED(0.0);
    ball_init(b,pos,speed, mass);
  }
  
  // go
  while (!stop) {

    // quit ? all must press start
    int stopasked = TRUE;
    for (i=0;i<game->n_player;i++){
      int all_cipiues = TRUE;
      PLAYER *p = &(game->player[i]);
      if (p->pad_num != IS_CIPIU){
	Sint16 padd =  ~(Smpc_Peripheral[p->pad_num].data);
	stopasked = (stopasked && (padd & PER_DGT_ST));
	all_cipiues = FALSE;
      } 
      if (all_cipiues){
	stopasked = pad_someone_presses(PER_DGT_ST,0);
      }
      //  stopasked = (stopasked && (!all_cipiues));
    }
    game->ga_options->instant_match = stopasked;

    if (pause){

      // check if new player
      for (i=0;i<MAX_PAD_NB;i++){
	Sint16 padp =  ~(Smpc_Peripheral[p_pad[i]].push);
	//	Sint16 padd =  ~(Smpc_Peripheral[p_pad[i]].data);

	if ((padp & PER_DGT_TA)){ // request new player
	  if (get_player_by_pad_num(game,p_pad[i])<0){
	    if (game->n_player<MAX_PLAYER_NB){ // some room left for a new player ?
	      int pl_num = game->n_player;
	      // create player	    
	      FIXED pos[XYZS];
	      int pl_pad;
	      pos[X] = give_random_x_by_team_nb(pauser_team,game->n_team);
	      pos[Y] = minmaxrnd(toFIXED(-40.0),toFIXED(40.0));
	      FIXED mass = MASS_PLAYER;
	      int spr = find_next_unused_pl_sprite(game->player,pl_num,FIRST_PLAYER_SPR);
	      if (spr == -1) spr = FIRST_PLAYER_SPR; //hum...
	      // init_player

		pl_pad = p_pad[i];

	      player_init(&(game->player[pl_num]),pl_pad, pos, mass,pauser_team, spr);
	      game->player[pl_num].speed[X] = minmaxrnd(toFIXED(-5.0),toFIXED(5.0));
	      game->player[pl_num].speed[Y] = minmaxrnd(toFIXED(-1.0),toFIXED(5.0));
	      game->n_player++;
	    }
	  }
	}
      }

      // remove pause ?
      for (i=0;i<game->n_player;i++){
	PLAYER *p = &(game->player[i]);
	if (p->pad_num!=IS_CIPIU){
	  Sint16 padp =  ~(Smpc_Peripheral[p->pad_num].push);
	  // stop pause ?
	  if (padp & PER_DGT_TL){
	    pause  = !pause;
	  }
	}
      }
    } else {   

      // game modes (bonuses)
      b_proat_mode = FALSE;
      if (b_nosferatu_count>=0) b_nosferatu_count--;
      if (b_kingkong_count>=0) b_kingkong_count--;  
      if (b_throther_count>=0) b_throther_count--;
      if (b_liste_des_fuckings_count>=0)  b_liste_des_fuckings_count--;
      if (b_jumbo_jim_count>=0) b_jumbo_jim_count--;
      b_chomplet_mode = FALSE;
      b_long_drink_mode = FALSE;

      if (next_distrib<toFIXED(0.0)) {
	next_distrib = distribute_bonuses(game);
      } 
      next_distrib = next_distrib - toFIXED(0.02);

      // make cipius think and act.    
      for (i=0;i<game->n_cipiu;i++){
	CIPIU* c = &(game->cipiu[i]);
	cipiu_play(c,(void*)game,(void*)ball);

	// oh, it's copied from a few lines below...
	if (c->fire_bonus){
	  switch (player_options_pop(&(c->p->options))){
	  case no_bonus:	    break;
	  case  proat :	    b_proat_mode = TRUE;	    break;
	  case  kingkong :  b_kingkong_count = 70;	    break;
	  case  nosferatu : b_nosferatu_count = 70;         break;
	  case throther :   
	    if (b_throther_count>=0) {
	      b_throther_count = 0;
	    } else {
	      b_throther_count = 80;
	    }
	    break;
	  case kansas: c->p->speed[Y] += toFIXED(3.0);   break;
	  case liste_des_fuckings:  b_liste_des_fuckings_count = 40;    break;
	  case chomplet: b_chomplet_mode = TRUE;   break;
	  case long_drink:  b_long_drink_mode = TRUE;    break;
	  case jumbo_jim : b_jumbo_jim_count = 300; break;
	  default: 	    break;
	  }
	  c->fire_bonus = 0;
	}
      }

      // obey player's input and compute player position
      for (i=0;i<game->n_player;i++){
	FIXED left,right;
	PLAYER *p;
	p = &(game->player[i]);

	if (p->pad_num != IS_CIPIU){ // the player is not a cipiu 

	  Sint16 padd,padp;
	
	  // update automata
	  automata_feed(&(p->pad_fsa),Smpc_Peripheral[p->pad_num].push);
	  automata_step(&(p->pad_fsa));   

	  // combos 
	  switch (automata_get_state_id(&(p->pad_fsa))){
	  case xy :	
	  case yx :	
	    // if (p->options.has[super_jump]){
	    // not on the ground
	    // if (p->pos[Y]>(POS_BOTTOM+PLAYER_SPR_CENTER_OFFSET))
	    switch (game->ga_options->control_set){
	    case cs_slime : 
	    case cs_floupix_con : break;
	    case cs_standard : 
	    case cs_combo :
	    default : 
	      player_give_gaz(p);
	      p->speed[Y] = toFIXED(-3.0);
	    }	
	    break;
	  default : 
	    break;  
	  }
	  
	  // normal controls
	  padp = ~(Smpc_Peripheral[p->pad_num].push);
	  padd = ~(Smpc_Peripheral[p->pad_num].data);
	  
	  // get bonus ?
	  switch (game->ga_options->distrib){
	  case ok_corral :
	    if (padp & PER_DGT_TC){  
	      E_BONUS type = get_random_bonus(game->ga_options);
	      player_options_queue(&(p->options),type,MAX_BONUS_NB);   
	    }	
	    break;
	  case smooth :
	  default :
	    break;
	  }
	  
	  // super jump ?
	  if (padp & PER_DGT_TA){
	    switch (game->ga_options->control_set){
	    case cs_standard :
	    case cs_slime :    break;
	    case cs_floupix_con : 
	    case cs_combo :
	    default : 
	      player_give_gaz(p);
	      p->speed[Y] = toFIXED(-3.0);
	    }
	  }
	  
	  // use bonus
	  if (padp & PER_DGT_TB){
	    switch (player_options_pop(&(p->options))){
	    case no_bonus:	    break;
	    case  proat :	    b_proat_mode = TRUE;	    break;
	    case  kingkong :  b_kingkong_count = 70;	    break;
	    case  nosferatu : b_nosferatu_count = 70;         break;
	    case throther :   
	      if (b_throther_count>=0) {
		b_throther_count = 0;
	      } else {
		b_throther_count = 80;
	      }
	      break;
	    case  kansas: p->speed[Y] += toFIXED(3.0);   break;
	    case liste_des_fuckings:  b_liste_des_fuckings_count = 40;    break;
	    case chomplet: b_chomplet_mode = TRUE;   break;
	    case long_drink:  b_long_drink_mode = TRUE;    break;
	    case jumbo_jim : b_jumbo_jim_count = 300; break;
	    default: 	    break;
	    }
	  }
	  
	  // pause : tl
	  if (padp & PER_DGT_TL){
	    pause  = !pause;
	    pauser_team = p->team;
	  }
	  
	  if (padp & PER_DGT_TZ) {
	    p->options.go_trough_net = !p->options.go_trough_net;
	  }
	  
	  // moves + , A 
	  if (padd & PER_DGT_KL) p->speed[X] -= toFIXED(1.0);
	  if (padd & PER_DGT_KR) p->speed[X] += toFIXED(1.0);
	  if ((padd & PER_DGT_TA)&&(p->pos[Y]==(POS_BOTTOM+PLAYER_SPR_CENTER_OFFSET))){
	    switch (game->ga_options->control_set){
	    case cs_combo :
	    case cs_floupix_con : break;
	    case cs_slime : 
	    case cs_standard : 
	    default : 
	      p->speed[Y] = toFIXED(-3.0);
	      p->pos[Y] = (POS_BOTTOM+PLAYER_SPR_CENTER_OFFSET);
	    }
	  }
	}

	// apply physics
	apply_gravity(p->pos,p->speed,p->mass,w);
	
	if (p->pos[Y]<(POS_BOTTOM+PLAYER_SPR_CENTER_OFFSET))
	  apply_air_friction(p->pos,p->speed,w);
	
	apply_ground_friction(p->pos,p->speed,w);
	
	apply_speed_limit(p->pos,p->speed,w);
	p->last_pos[X] = p->pos[X];
	p->last_pos[Y] = p->pos[Y];
	apply_speed(p->pos,p->speed,w);
	
	// check nets & boundaries
	if (p->options.go_trough_net) {
	  left = POS_LEFT; 
	  right = POS_RIGHT;
	} else {
	  switch (p->team){
	  case 0 : 
	    left = POS_LEFT; 
	    right = game->net[0].pos[X]; 
	    break;
	  case 1 : 
	    left = game->net[0].pos[X];
	    right = (game->n_net == 1)?POS_RIGHT:game->net[1].pos[X];
	    break;
	  case 2 : 
	  default:
	    left =  game->net[1].pos[X];
	    right = POS_RIGHT;
	  }
	  // removes the need for the player to press Z two times 
	  p->options.go_trough_net = TRUE;
	} 
	
	left = left + PLAYER_SPR_RADIUS;
	right = right -  PLAYER_SPR_RADIUS;
	
	if (p->pos[X]<left)  {
	  p->pos[X] = left;
	  p->speed[X] = toFIXED(0.0);
	}
	if (p->pos[X]>right) {
	  p->pos[X] = right;
	  p->speed[X] = toFIXED(0.0);
	}
	
	if (p->pos[Y]>(POS_BOTTOM+PLAYER_SPR_CENTER_OFFSET)) {
	  p->pos[Y] = (POS_BOTTOM+PLAYER_SPR_CENTER_OFFSET);
	  p->speed[Y] = toFIXED(0.0);
	}
	
	if (p->pos[Y]<POS_TOP) {
	  p->pos[Y] = POS_TOP;
	  p->speed[Y] = toFIXED(0.0);
	}
      }
      
      // new ball
      if (b_long_drink_mode){
	int i;
	n_ball+=1;
	if (n_ball>=MAX_BALL_NB) n_ball=MAX_BALL_NB;
	BALL *b1 =  &(ball[n_ball-2]);
	BALL *b2 =  &(ball[n_ball-1]);
	for (i=0;i<XYZS;i++)  {b2->pos[i] = b1->pos[i];}
	for (i=0;i<XYZS;i++)  {b2->last_pos[i] = b1->last_pos[i];}
	for (i=0;i<XY;i++) {b2->speed[X] = slMulFX(toFIXED(-1.0),b1->speed[i]);}
	for (i=0;i<XY;i++) {b2->speed[Y] = b1->speed[Y];}
      }
    
      
      // compute balls position
      
      for (i=0;i<n_ball;i++){

	BALL *b =  &(ball[i]);

	if (b_proat_mode) b->speed[Y] -= toFIXED(4.0);
	if (b_chomplet_mode) {
	  b->speed[X] = toFIXED(0.0);
	  b->speed[Y] = toFIXED(0.0);
	}
	
	if (b->pos[Y]>(POS_BOTTOM-BALL_SPR_RADIUS)) {  // 1. end of exchange
	  //	scrollTxtAddTxtLine("end exch      ");
	  b->pos[Y] = (POS_BOTTOM-BALL_SPR_RADIUS);
	  b->speed[Y] =  slMulFX(toFIXED(-1.0),b->speed[Y]);
	  if (i==0) stop = TRUE; // only the first ball
	  if (b_kingkong_count>=0) stop = FALSE;
	} else {
	  if ((b_throther_count>=0)||(b->pos[Y]>(POS_BOTTOM - NET_HEIGHT - BALL_SPR_RADIUS))) {
	    //2. check nets if ball low 
	    int in = 0;
	    FIXED left, right;                    
	    for (in = 0;in<game->n_net;in++){      // (for all net positions...
	      FIXED xb = b->pos[X];
	      left = right = game->net[in].pos[X];
	      left = left - BALL_SPR_RADIUS - NET_SEMI_WIDTH;
	      right = right + BALL_SPR_RADIUS + NET_SEMI_WIDTH;
	      if ((xb>left)&&(xb<right)){         // collision detected
		if (b_throther_count>=0){	        // 2.05 throther mode
		  b->pos[X] = (b->speed[X]>toFIXED(0.0))?left:right;
		  b->speed[X] = - (b->speed[X]);
		} else {
		  if (b->pos[Y]<(POS_BOTTOM-NET_HEIGHT)){ // 2.1 top of the net
		    b->speed[Y] = - slSquartFX(slMulFX((b->speed[Y]),(b->speed[Y])));
		  } else {                                // 2.2 vertical net
		    b->pos[X] = (b->speed[X]>toFIXED(0.0))?left:right;
		    b->speed[X] = - (b->speed[X]);
		  }
		}
	      }
	    }
	  } 
	  
	  // 3. if ball is not low, check only screen boundaries
	  if (b->pos[X]<(POS_LEFT+BALL_SPR_RADIUS))  {
	    b->pos[X] = POS_LEFT+BALL_SPR_RADIUS;
	    b->speed[X] = slMulFX(toFIXED(-1.0),b->speed[X]);
	  }
	  if (b->pos[X]>(POS_RIGHT-BALL_SPR_RADIUS)) {
	    b->pos[X] = POS_RIGHT-BALL_SPR_RADIUS;
	    b->speed[X] = slMulFX(toFIXED(-1.0),b->speed[X]);
	  }
	  if (b_jumbo_jim_count<0) { // top of the screen if jumbo_jim not on
	    if (b->pos[Y]<(POS_TOP+BALL_SPR_RADIUS)) {
	      b->pos[Y] = POS_TOP+BALL_SPR_RADIUS;
	      b->speed[Y] = slMulFX(toFIXED(-1.0),b->speed[Y]);
	    }
	  }
	}
      }
      
      
      if (!stop){

	
	// collisions of balls & players.
	for (i=0;i<n_ball;i++){
	  BALL *b =  &(ball[i]);
	  int j;
	  int collides = FALSE;
	  
	  if (b_nosferatu_count<=0){ // if nosferatu, no collisions.
	    for (j=0;j<(game->n_player);j++){
	      
	      PLAYER *p = &(game->player[j]);
	      FIXED sq_distx,sq_disty;
	      FIXED max_radius = BALL_SPR_RADIUS+PLAYER_SPR_RADIUS;
	      
	      sq_distx = p->pos[X] - b->pos[X];
	      if ((sq_distx <(max_radius))
		  && (sq_distx > (-max_radius))){
		sq_disty = p->pos[Y] - b->pos[Y];
		if ((sq_disty < (max_radius)) 
		    && (sq_disty > (-max_radius))){
		  sq_distx = slMulFX(sq_distx,sq_distx);
		  sq_disty = slMulFX(sq_disty,sq_disty);
		  FIXED hypo = slSquartFX(sq_distx + sq_disty);
		  if (hypo<(max_radius)){
		    compute_boucing_ball_speed(b,p); 
		    collides = TRUE;
		  }
		}
	      }
	    }
	  }

	  // only if no collision detected.
	  if (!collides){
	    apply_gravity(b->pos,b->speed,b->mass,w);
	    //apply_air_friction(b->pos,b->speed,w);
	  }

	  if (collides) {
	      sound_play(snd_bing);
	  }
	  
	  // apply physics
	  apply_speed_limit(b->pos,b->speed,w);
	  b->last_pos[X] = b->pos[X];
	  b->last_pos[Y] = b->pos[Y];
	  apply_speed(b->pos,b->speed,w);
	}
      }
    }
  
    // paused or not, do :

    // display players
    for (i=0;i<game->n_player;i++){
      PLAYER *p = &(game->player[i]);
      player_display(p);
      player_options_move(&(p->options),p->last_pos);
      player_options_display(&(p->options));
    }
    

    // display balls
    if (!(b_liste_des_fuckings_count>=0)) {
      for (i=0;i<n_ball;i++){
	BALL *b =  &(ball[i]);
	ball_display(b);
	// ball_dbg_display_speed(b,20,1);
      }
    }

    // display nets
    for (i=0;i<game->n_net;i++){
      NET *n =  &(game->net[i]);
      net_display(n);
    }  
    

    // display bonus mode
    if (b_kingkong_count >=0) {
      FIXED pos[] = {toFIXED(-25.0), POS_TOP+toFIXED(20.0),toFIXED(169.0),toFIXED(3.0)};
      ANGLE ang = DEGtoANG(0.0);
      display_bonus_sprite(pos,ang,kingkong);
    }
    if (b_nosferatu_count >=0) {
      FIXED pos[] = {toFIXED(-16.0), POS_TOP+toFIXED(20.0),toFIXED(169.0),toFIXED(3.0)};
      ANGLE ang = DEGtoANG(0.0);
      display_bonus_sprite(pos,ang,nosferatu);
    }
    if (b_throther_count >=0) {
      FIXED pos[] = {toFIXED(0.0), POS_TOP+toFIXED(20.0),toFIXED(169.0),toFIXED(3.0)};
      ANGLE ang = DEGtoANG(0.0);
      display_bonus_sprite(pos,ang,throther);
    }
    if (b_liste_des_fuckings_count >=0) {
      FIXED pos[] = {toFIXED(16.0), POS_TOP+toFIXED(20.0),toFIXED(169.0),toFIXED(3.0)};
      ANGLE ang = DEGtoANG(15.0);
      display_bonus_sprite(pos,ang,liste_des_fuckings);
    }
    if (b_jumbo_jim_count >=0) {
      FIXED pos[] = {toFIXED(25.0), POS_TOP+toFIXED(20.0),toFIXED(169.0),toFIXED(2.0)};
      ANGLE ang = DEGtoANG(15.0);
      display_bonus_sprite(pos,ang,jumbo_jim);
    }
    // display score 
    // display_scores(game);

    // update n_team_change and act accordingly
    n_team_change = 0;

    //    debug_world(w);
    
    scrollTxtSchedule();    
    scrollTxtDisplay();

    slSynch();
  }
  exch_ret->next_distrib = next_distrib;
  exch_ret->losing_team = net_get_team_from_x(game->net, game->n_net,ball[0].pos[X]);

}

/* update the teams scores after according to the winner
 * returns TRUE if the game is over */
int sub_update_scores(GAME* game,EXCHANGE_RESULT* exch_ret){
  int i;
  int over = FALSE;
  int lt = exch_ret->losing_team;        // last winner
  int max_points;

  // update score
  if (game->n_team == 2){
    int wt = (lt==0)?1:0;
    game->team[wt].points +=1;
  } else {
    for (i=0;i<game->n_team;i++){
      TEAM* t = &(game->team[i]);
      if (i == lt) {t->points -=1;} else {t->points +=1;}
    }
  }
  
  max_points = game_options_get_max_point(game->ga_options);
  
  // game is over ?
  for (i=0;i<game->n_team;i++){
    TEAM* t = &(game->team[i]);
    if (t->points == (max_points)) over = TRUE;
    if (t->points == (-1*(max_points))) over = TRUE;
  }
  if (game->ga_options->instant_match) over = TRUE;


  return over;
}

// returns true if wants to play again
int sub_match_outro(GAME* game){
  int i;

  int exit = FALSE;
  int mincount = 100;      // outro timeout
  int play_again = FALSE;

  int best_score = -1;
  int wt = -1;       
  int rotate_timeout = 0;
  
  clear_screen();

  // calculate winner team (wt) according 
  // to the best score
  for (i=0;i<game->n_team;i++){
    int ts = game->team[i].points;
    if (ts>best_score) {
      best_score = ts;
      wt = i;
    }
  }
  
  display_scores(game);
  
  // display winners until stop
  while (!exit) {
    for (i=0;i<game->n_player;i++){
      PLAYER* p = &(game->player[i]);
      FIXED fypos;
      fypos = toFIXED(1.0*(game->team[p->team].points-(game_options_get_max_point(game->ga_options))));     
      fypos = slMulFX(-POS_BOTTOM,slDivFX(toFIXED(2.0*(game_options_get_max_point(game->ga_options))),fypos));
      p->pos[Y] = p->pos[Y] + slDivFX(toFIXED(30.0),(fypos-p->pos[Y]));

      if (p->team == wt){
	p->pos[S] = p->pos[S] + slDivFX(toFIXED(20.0),(toFIXED(3.0)-p->pos[S]));
      } 

      player_display(p);
    }

    if (mincount == 50){
      slPrint("press <A> for the same floupix",slLocate(10,27));
    }
    if (mincount == 0){
      slPrint("           <START> to continue",slLocate(10,28));
    }

    if (mincount--<0){  // wait before player can quit this screen
      play_again = pad_someone_presses(PER_DGT_TA,1);
      exit = (play_again || pad_someone_presses(PER_DGT_ST,1));
    }

    if (mincount<0){
      // rotate palette 
      if (rotate_timeout == 0){
	if (fadeCRAM((void *)NBG1_COL_ADR , 256)){
	  rotate_timeout = -1;
	};
	rotate_timeout = 3;
      } else {
	rotate_timeout--;
      }
    }

    // display nets
    for (i=0;i<game->n_net;i++){
      NET *n =  &(game->net[i]);
      net_display(n);
    }  
    
   

    //    display_scores(game);
    slSynch();
  }

  // erase
  clear_screen();
  fl_picture_display(&pic); // restores the color map
  return play_again;
}

void sub_sysiphe_special(GAME* game){
  int max_points = game_options_get_max_point(game->ga_options);
  int is_really_over = 0;
  int i;
  
  // displays the win. pict.it ONLY IF
  //  the game has gone to its natural end.
  for (i=0;i<game->n_team;i++){
    TEAM* t = &(game->team[i]);
    is_really_over = ((is_really_over) || (max_points == t->points));
  }

  if (is_really_over){
    int time = 0;
    fl_picture_load_and_forget(BACKGROUND_SYSIPHE_WINNER);
    // le monde entier a droit  une punition.
    //if (game->ga_options->cd_music == cdmusic_on) 
    fl_cdda_playcd(CD_TRACK_SYSIPHE_WIN);
    while (TRUE){
      if (time-- < -50) time = 50;
      if (time==50) slPrint("    over",slLocate(23,13));
      if (time==0)  slPrint("game    ",slLocate(23,13));
      slSynch();
    }
  }
}

/*
 *                 MATCH
 */

int sub_match(GAME* game){
  int stop = FALSE;
  EXCHANGE_RESULT exch_res;
  EXCHANGE_RESULT *res = &(exch_res);
  int replay; 
  static WORLD world;
  WORLD* w = &world;
  //             gravity,  ground_friction, air_friction, speed_limit;
  world_init(w,toFIXED(0.02),toFIXED(0.55), toFIXED(0.99),toFIXED(5.0)); 
  
  res->next_distrib =  toFIXED(-1.0);  
  while (!stop) {
    // display score 
    display_scores(game);
    // init exchange_result structure
    init_exchange_resu(res,res->next_distrib);
    // go do the exchange
    sound_play(snd_good);
    sub_exchange(game,w,res);     
    // update scores, and replay, exchange winner is res->losing_team
    stop = sub_update_scores(game,res);
  }

  if (game->ga_options->game_lenght == gl_sysiphe){
    sub_sysiphe_special(game);
  }
  replay = sub_match_outro(game);
  return replay;
}

/*
 *    DEBUG
 */

void debug_print_all_sprites(){
  int pressed = FALSE;
  
  while (!pressed) {
    
    FIXED posX = toFIXED(-100.0);
    FIXED posY = toFIXED(-100.0);
    static ANGLE ang = DEGtoANG(0.0);  
    ang += DEGtoANG(30.0);

    int i;
    for (i=0;i<SPRITE_NB;i++){
      FIXED pos[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(169.0),toFIXED(1.0)};
        
      pos[X] = posX;
      pos[Y] = posY;
      //      pos[Z] = toFIXED(169.0);
      //      pos[S] = toFIXED(1.0);      
      slDispSprite(pos, (SPR_ATTR *)(&attr[i].texno), ang); 
      posX+= toFIXED(32.0);
      if (posX>toFIXED(100.0)){
	posX = toFIXED(-100.0);
	posY += toFIXED(32.0);
      }
    }    

    slSynch();
    pressed =  (!(Smpc_Peripheral[0].data & PER_DGT_ST));
  }
}

void debug_test_combos(AUTOMATA* au){
  int last_state=0;
  for (;;){
    automata_feed(au, Smpc_Peripheral[0].push);
    automata_step(au);   
    slPrintFX(toFIXED(au->timer.time*1.0),slLocate(20,1));
    if (last_state!=(automata_get_state_id(au))){
      switch (automata_get_state_id(au)){
      case x :	scrollTxtAddTxtLine("x        ");	break;
      case xy :	scrollTxtAddTxtLine("xy       ");	break;
      case y : 	scrollTxtAddTxtLine("y        ");	break;
      case yx :	scrollTxtAddTxtLine("yx       ");	break;  
      case start : scrollTxtAddTxtLine("start    ");	break;  
      default :	scrollTxtAddTxtLine("undef    ");	break;
      }
    }
    last_state = (automata_get_state_id(au));
    //  scrollTxtSchedule();    
    scrollTxtDisplay();    
  }
}


void disp_tree(STATE* st){
  int i;
  static int pos=0;

  slPrint("(",slLocate(20,++pos)); 
  switch (st->id){
  case x     : slPrint("x",slLocate(22,pos));  break;
  case xy    : slPrint("xy",slLocate(22,pos)); break;
  case y     : slPrint("y",slLocate(22,pos));  break;
  case yx    : slPrint("yx",slLocate(22,pos)); break;  
  case start : slPrint("start",slLocate(22,pos)); break;  
  default :    slPrint("def",slLocate(22,pos)); break;
  }
  slPrintFX(toFIXED(1.0*(st->max_time)),slLocate(22,++pos));
  slPrintFX(toFIXED(1.0*(st->n_trans)),slLocate(22,++pos));

  slPrintHex((int)st->trans,slLocate(10,pos));
  
  for (i=0;i<st->n_trans;i++){  
    TRANSITION* tr = st->trans[i];
    slPrintHex((int)st,slLocate(10,pos+1));
    disp_tree(tr->st);
  }
  slPrint(")",slLocate(20,++pos));  
}

void debug_print_combos(AUTOMATA* au){
  int pressed = FALSE;
  
  disp_tree(au->start);
  while (!pressed){
    slSynch();
    pressed =  (!(Smpc_Peripheral[0].data & PER_DGT_ST));
  }
 
}

/*
 * MAIN
 */



int man_move(FIXED y, FIXED scale,int frameskip){
  FIXED pos[XYZS];
  /*  FIXED offset[] = {(toFIXED(0.0)),(toFIXED(-2.0)),(toFIXED(-6.0)),(toFIXED(-15.0)),(toFIXED(-33.0)),
		    (toFIXED(0.0)),(toFIXED(-2.0)),(toFIXED(-6.0)),(toFIXED(-15.0)),(toFIXED(-33.0))};
  */
  FIXED offset[] = {(toFIXED(0.0)),(toFIXED(-2.0)),(toFIXED(-4.0)),(toFIXED(-9.0)),(toFIXED(-18.0))};

  FIXED posb[7][XYZS];
  int spr[7];
  int more = TRUE;

  ANGLE ang =  DEGtoANG(0.0);
  int i;

  for (i=0;i<7;i++){
    spr[i] = minmaxrndint(FIRST_BONUS_SPR,LAST_BONUS_SPR);
    posb[i][X] = POS_LEFT+slMulFX(slDivFX(toFIXED(6.0),(POS_RIGHT-POS_LEFT)),toFIXED(1.0*i));
    posb[i][Y] = POS_TOP+minmaxrnd(toFIXED(-50.0),toFIXED(0.0));
    //    posb[i][Z] = toFIXED(170.0);
    posb[i][Z] = toFIXED(169.0);
    posb[i][S] = minmaxrnd(toFIXED(1.0),toFIXED(2.0));
    slDispSprite(posb[i], (SPR_ATTR *)(&attr[spr[i]].texno), ang);   
    slSynch();

  }

  pos[X] = POS_RIGHT+slMulFX(toFIXED(32.0),scale);
  pos[Y] = y;
  pos[Z] = toFIXED(169.0);
  pos[S] = scale;
  
  while (more) {
    more  = FALSE;

    for (i=0;i<(LAST_RUN-FIRST_RUN+1);i++){
      int j=0;
      int k;
      pos[X] += slMulFX(scale,offset[i]);
      
      
      while (j<=frameskip){
	slDispSprite(pos, (SPR_ATTR *)(&attr[LAST_RUN-i].texno), ang);   


	for (k=0;k<7;k++){
	  spr[k] = minmaxrndint(FIRST_BONUS_SPR,LAST_BONUS_SPR);
	  if (pos[X]>posb[k][X]){
	    posb[k][X] += minmaxrnd(toFIXED(0.5),toFIXED(2.0));
	  } else {
	    posb[k][X] -= minmaxrnd(toFIXED(0.5),toFIXED(2.0));
	  }
	  posb[k][Y] += minmaxrnd(toFIXED(0.1),toFIXED(2.0));
	  slDispSprite(posb[k], (SPR_ATTR *)(&attr[spr[k]].texno), ang);   
	  more =(more || (posb[k][Y]<(POS_BOTTOM+toFIXED(10.0))));
	}
	slSynch();
	j++;
      }
    }
    more = (more || (pos[X]>(POS_LEFT-slMulFX(toFIXED(32.0),scale))));
    pos[X] += slMulFX(toFIXED(-16.0),scale);
  }
  return 1;
}

void randomize() {
  int out = FALSE;
  int rotate_timeout=0;
  int max_rotate_timeout=1;
  int top,left;

  FIXED useless = toFIXED(666.0);

  top = 0;
  left = 0;

  fl_picture_load(&pic,BACKGROUND_FIRST);  
  fl_picture_display(&pic);
  slPrint(" Somebody please press start. ",slLocate(5,15));
    
  while (!out){
    slSynch();
    useless = slRandom();
    slPrintFX(useless,slLocate(12,22));
    out = pad_someone_presses(PER_DGT_ST, TRUE);

    // rotate palette 
    if (rotate_timeout == 0){
      rotateCRAM((void *)NBG1_COL_ADR , 256);
      rotate_timeout = max_rotate_timeout;
    } else {
      rotate_timeout--;
    }  

    if (pad_someone_presses(PER_DGT_KU, TRUE)) {
      top -= 5;
    } else if (pad_someone_presses(PER_DGT_KD, TRUE)) {
      top += 5; 
    } else if (pad_someone_presses(PER_DGT_KL, TRUE)) {
      left -=  5;
    } else if (pad_someone_presses(PER_DGT_KR, TRUE)) {
      left += 5;
    }

    
    slScrPosNbg1(left, top);


  }
}

void sub_load_background_and_music(GAME_OPTIONS* go){
  if (go->game_lenght == gl_sysiphe){
    fl_picture_load(&pic,BACKGROUND_SYSIPHE);
    fl_picture_display(&pic);
    //    if (go->cd_music == cdmusic_on) 
    fl_cdda_playcd(CD_TRACK_SYSIPHE);
  } else {
    fl_picture_load(&pic,minmaxrndint(BACKGROUND_FIRST,BACKGROUND_FIRST+BACKGROUND_NB-1));
    fl_picture_display(&pic);

    if (go->cd_music == cdmusic_on) fl_cdda_playcd(minmaxrnd(CD_TRACK_MIN,CD_TRACK_MAX));
  }
}

void vbt_init(){
  Uint8	*dst;
  Uint16  loop;

  // 1.Zero Set .bss Section
  for (dst = (Uint8 *)&_bstart; dst < (Uint8 *)&_bend; dst++){
    *dst = 0;
  }
  
  // 2.SGL System Variable Clear
  for (dst = (Uint8 *)SystemWork, loop = 0; loop < SystemSize; loop++){
    *dst = 0;
  }
  iZoom=1;
  file_id=1;
  dir_id=1;

  InitCD();

}

void ss_main() {
 
  GAME game;
  TEAM team[MAX_TEAM_NB];
  NET net[MAX_NET_NB];
  PLAYER player[MAX_PLAYER_NB];
  STATE* pad_fsa_root=(STATE*)NULL;
  OPTIONS_MENU options_menu;
  GAME_OPTIONS ga_options;
  CIPIU cipiu[MAX_CIPIU_NB];
  int replay;

  slInitSystem(TV_320x240, tex_spr,1);
  set_sprite(pic_spr, SPRITE_NB);
  sound_init();
  vbt_init();
  scrollTxtInit();
  build_combo_tree(&pad_fsa_root);
  game_options_init(&ga_options);
  options_menu_init(&options_menu);
  persist_get(&ga_options);   // get options from backup memory

  //  disp_tree(pad_fsa_root);
  // debug_print_all_sprites();  
  initPicField();

  randomize();
  clear_screen();

  sub_load_background_and_music(&ga_options);
  
  /*
    if (ga_options.cd_music == cdmusic_on) 
    fl_cdda_playcd(minmaxrnd(CD_TRACK_MIN,CD_TRACK_MAX));
  */

  replay = FALSE;
  // action
  for (;;) {

    int n_team;int n_net;int n_player;int n_cipiu;
    int i;

    // attacf combo fsa data to each player
    for (i=0;i<MAX_PLAYER_NB;i++){
      automata_define(&(player[i].pad_fsa), pad_fsa_root);
    }

    // debug_test_combos(&(player[0].pad_fsa));
    // debug_print_combos(&(player[0].pad_fsa));
    
    // choose team number and init teams
    if (!replay){
      n_team = sub_ask_for_team_number_and_options(&ga_options,&options_menu);
      n_net  = n_team-1;
    } 

    for (i=0;i<n_team;i++){   
      TEAM* t = &(team[i]);
      team_init(t);
    }	       

    sub_load_background_and_music(&ga_options);

    if (!replay){
      // determine positions of the net and init it.
      for (i=0;i<n_net;i++){   
	FIXED xpos;
	NET* n;
	xpos = POS_LEFT + slMulFX(toFIXED((i+1)*1.0),slDivFX(toFIXED(n_team*1.0),toFIXED(320.0)));
	n = &(net[i]);     
	net_init(n,xpos);
      }	       
      
      // player tell they want to play and init them
      n_player = sub_players_team_choice(n_team,player,net,cipiu,&n_cipiu);
      
      //    man_move(POS_BOTTOM-slMulFX(toFIXED(32.0),toFIXED(0.5)),toFIXED(0.5),2); 
      
      // init the game.
    } else {
      for (i=0;i<n_player;i++){
	player_reinit(&(player[i]));
      }
    }
    
    game_init(&game,team, n_team, player, n_player, cipiu, n_cipiu, net, n_net,&ga_options);
    
    // play 
    replay = sub_match(&game);
    clear_screen();

  }
}










