/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

  /*
   * Display and interaction of option menu
   */

#include "sgl.h"
#include "libpad.h"
#include "fldefs.h"
#include "options.h"

  //extern int* p_pad;

#define MAX_PAD_NB_X 7
  int p_padX[] = {0,1,2,3,4,5,15};  // physical pad number

// displays options menu
void options_menu_display(OPTIONS_MENU* om){
  int line=12;
  int col=25;

  slPrint("~ Options ~",slLocate(15,7));
  // Control set

  slPrint(" ",slLocate(1,line));  
  slPrint("controls : ",slLocate(col-12,line));
  switch (om->value[0]){
  case cs_standard:    slPrint("standard   ",slLocate(col,line));    break;
  case cs_floupix_con: slPrint("floupix con",slLocate(col,line));    break;
  case cs_combo:       slPrint("combo      ",slLocate(col,line));    break;
  case cs_slime :
  default :      
    slPrint("slime      ",slLocate(col,line));
  }  

  // Distrib rule
  line++;
  slPrint(" ",slLocate(1,line));  
  slPrint("bonus distribution : ",slLocate(col-22,line));
  switch (om->value[1]){
  case ok_corral: slPrint("ok corral",slLocate(col,line));    break;
  case boumtou:   slPrint("boumtou  ",slLocate(col,line));    break; 
  case smooth:    slPrint("smooth   ",slLocate(col,line));    break; 
  case chainsaw : slPrint("chainsaw   ",slLocate(col,line));    break; 
  case straight:  slPrint("straight ",slLocate(col,line));    break;
  case none:   
  default :       slPrint("none     ",slLocate(col,line));
  }  
  
  // Game length
  line++;
  slPrint(" ",slLocate(1,line));  
  slPrint("game length : ",slLocate(col-15,line));
  switch (om->value[2]){
  case gl_flash     : slPrint("flash    ",slLocate(col,line));    break;
  case gl_short     : slPrint("short    ",slLocate(col,line));    break;
  case gl_long      : slPrint("long     ",slLocate(col,line));    break;
  case gl_very_long : slPrint("very long",slLocate(col,line));    break;
  case gl_endless   : slPrint("endless  ",slLocate(col,line));    break;
  case gl_sysiphe   : slPrint("sysiphe  ",slLocate(col,line));    break;
  case gl_medium    : 
  default      : slPrint("medium   ",slLocate(col,line));    break;
  }  

  // Game length
  line++;
  slPrint(" ",slLocate(1,line));  
  slPrint("bonus collection :",slLocate(col-20,line));
  switch (om->value[3]){
  case bc_normal     : slPrint("normal           ",slLocate(col,line));    break;
  case bc_xaporu     : slPrint("xaporu           ",slLocate(col,line));    break;
  case bc_blake      : slPrint("blake            ",slLocate(col,line));    break;
  case bc_balibali   : slPrint("bali-bali        ",slLocate(col,line));    break;
  case bc_lubion     : slPrint("lubion           ",slLocate(col,line));    break;
  case bc_glarpi     : slPrint("glarpi            ",slLocate(col,line));   break;
  case bc_power      : slPrint("power bonuses    ",slLocate(col,line));    break;
  default      : slPrint("normal   ",slLocate(col,line));    break;
  }  

  // music
  line++;
  slPrint(" ",slLocate(1,line));  
  slPrint("      music : ",slLocate(col-15,line));
  switch (om->value[4]){
  case cdmusic_on   : slPrint("on       ",slLocate(col,line));    break;
  case cdmusic_off  : slPrint("off      ",slLocate(col,line));    break;
  default      : slPrint("on      ",slLocate(col,line));    break;
  } 

  slPrint(">",slLocate(1,om->cur_option+12));
    
  slPrint("(B)ack     ",slLocate(18,25));
}




// change options
int options_menu_obey_pad(OPTIONS_MENU* om){
  int i;
  int stop = FALSE;
  Uint16 padp;

  for (i=0;i<MAX_PAD_NB_X;i++){
    padp = ~(Smpc_Peripheral[p_padX[i]].push);

    // choose option
    if (padp & PER_DGT_KU) om->cur_option -=1;
    if (padp & PER_DGT_KD) om->cur_option +=1;
    if (om->cur_option>=NB_OPTION) om->cur_option=0;
    if (om->cur_option<0) om->cur_option=NB_OPTION-1;

    // set option
    if (padp & PER_DGT_TA) {
      // controls
      (om->value[om->cur_option]) +=1;
      if (om->cur_option == 0) {       // controls
	if (om->value[om->cur_option]>cs_slime) om->value[om->cur_option]=0;
      } else if ( om->cur_option == 1){ // distribution
	if (om->value[om->cur_option]>ok_corral) om->value[om->cur_option]=0;
      } else if ( om->cur_option == 2){ // game lenght
	if  (om->value[om->cur_option]>gl_sysiphe) om->value[om->cur_option]=0;
      } else if ( om->cur_option == 3) { // bonus collection
	if (om->value[om->cur_option]>bc_power) om->value[om->cur_option]=0;
      } else if ( om->cur_option == 4) { // music
	if (om->value[om->cur_option]>cdmusic_off) om->value[om->cur_option]=0;
      }
    }

    // exit
    if (padp & PER_DGT_TB) {
      stop = TRUE;
    }
  }
  return stop;
}


// displays options menu
void options_menu_illustrate(OPTIONS_MENU* om){
  int i;
  static FIXED pos[BONUS_PROBA_SIZE][XYZS];
  static FIXED posx[BONUS_PROBA_SIZE];
  static FIXED xgoff = toFIXED(50.0);
  static FIXED xgoff_change = toFIXED(0.03);
  static FIXED mix=toFIXED(1.0);
  static FIXED mix_change = toFIXED(0.005);
  static int cur = 0;
  static int tempo = 0;
  static int size = 50;
  static int size_change = 1;
  static FIXED sin_offset = toFIXED(0.0);

  if ((tempo--) < 0)  {
    tempo = 3;
    if (cur++>=BONUS_PROBA_SIZE){
      cur = 0;
    }
    size += size_change;
  }
  
  mix = mix + mix_change;
  if ((mix>toFIXED(1.0))||(mix<toFIXED(0.0))){
    mix_change = slMulFX(toFIXED(-1.0),mix_change);
  }

  xgoff = xgoff + xgoff_change;
  if ((xgoff>toFIXED(50.0))||(xgoff<toFIXED(-50.0))){
    xgoff_change = slMulFX(toFIXED(-1.0),xgoff_change);
  }

  if ((size > 300) || (size <50)){
    size_change = -1*size_change;
  }

  sin_offset += toFIXED(0.01);

  if ((om->cur_option) == 3){
    for (i=0;i<BONUS_PROBA_SIZE;i++){
      ANGLE ang = DEGtoANG(0.0);
      E_BONUS bo = bonus_proba_get(om->value[3],i);
      pos[i][X] = toFIXED(1.0*(size*i/BONUS_PROBA_SIZE)) - toFIXED((size/2)*1.0);
      pos[i][Z] = toFIXED(150.0);
      if (cur == i){
	pos[i][S] = toFIXED(1.2);
      } else if ((cur == (i+1)) || (cur == (i-1))) {
	pos[i][S] = toFIXED(1.1);
      } else {
	pos[i][S] = toFIXED(1.0);
      }
      pos[i][Y] = toFIXED(50.0)+slMulFX(toFIXED(20.0),slSin(sin_offset+slDivFX(toFIXED(1.0*BONUS_PROBA_SIZE),toFIXED(1.0*i))));
      posx[i] = xgoff+slMulFX(toFIXED(20.0),slCos(sin_offset+slDivFX(toFIXED(1.0*BONUS_PROBA_SIZE),toFIXED(1.0*i))));
      pos[i][X] = slMulFX(mix,pos[i][X])+slMulFX((toFIXED(1.0)-mix),posx[i]);
      display_bonus_sprite(pos[i],ang,bo);
    }
  }
}




// activate (public)
void options_menu_activate(OPTIONS_MENU* om){
  int stop = FALSE;
  while (!stop){
    options_menu_display(om);
    options_menu_illustrate(om);
    stop = options_menu_obey_pad(om);
    slSynch();
  }
}

// init (public)
void options_menu_init(OPTIONS_MENU* om){
  om->cur_option = 0;
}
















