/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "sgl.h"

typedef struct _WORLD {
  FIXED gravity;           // vertical speeds ; *mass =  increment when falling
  FIXED ground_friction;   // [0..1] speedX <- friction*speedX
  FIXED air_friction;      // [0..1] the same with speed's norm
  FIXED speed_limit;       // see apply_speed_limit...
} WORLD;

void world_init(WORLD* w, FIXED gravity, FIXED gr_friction, FIXED air_friction, FIXED speed_limit);
void slow_speed(FIXED* speed, FIXED friction);
void limit_speed(FIXED* speed, FIXED limit);

// alter speed according to the gravity
// (only if object is NOT on the ground, )
void apply_gravity(FIXED* pos, FIXED* speed, FIXED mass, WORLD* world);

// reduce speed according to friction
// (called only if object is on the ground)
void apply_ground_friction(FIXED* pos, FIXED* speed, WORLD* world);

// reduce speed according to friction
// (called only if object is in the air)
void apply_air_friction(FIXED* pos, FIXED* speed, WORLD* world);

// change the speed according to world->speed_limit
void apply_speed_limit(FIXED* pos, FIXED* speed, WORLD* world);

// alter position according to speed
void apply_speed(FIXED* pos, FIXED* speed, WORLD* world);
