/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include	<sgl.h>
#include	<sgl_cd.h>
#include "string.h"
#include "vbt_file.h"

#define		MAX_FILE 512

void selectPic(unsigned char pic[],unsigned short palette[]);

extern unsigned short file_id, dir_id;
extern int sprintf (char *, const char *, ...);

void InitCD() {
  Sint32 dirwork[SLCD_WORK_SIZE(MAX_FILE)];
  Sint32 ndir;
  
  ndir = slCdInit(MAX_FILE, dirwork);

}

void ChooseFile(unsigned short prefix){
  char filename[50];
  char filenamePal[50];
  char toto[100];
  unsigned char Scene3[320*240];
  unsigned short Scene3Pal[513];

  sprintf(filename,"I%03d.BIN",prefix);
  sprintf(filenamePal,"I%03d.PAL",prefix);

  sprintf(toto,"Current file : %s                            ", filename);
  //  slPrint(toto,slLocate(2,19));

  if (LoadFile(filename, &Scene3[0x000], 192)==0) { //taille /16000    
    //    slPrint("End Loading picture...", slLocate(2,20));
    slSynch();

    load_color_proms(filenamePal,Scene3Pal);

    //    slPrint("End Loading Palette...", slLocate(2,21));
    selectPic(Scene3,Scene3Pal);
  }  else    {
    //    slPrint("rate", slLocate(2,15));
    file_id--;
  }
}

void ChangeDir(unsigned short prefix){
  Sint32 stat;
  char dirname[50];
  //  char toto[100];

  if (prefix > 0)
    sprintf(dirname,"P%04d",prefix);
  else
    sprintf(dirname,"..");
  //	
  file_id=0;

  stat= slCdChgDir(dirname);

  if (stat < 2) dir_id--;
  //	sprintf(toto,"CD %s  nb files : %d                            ", dirname,stat-2);
  slSynch();
  //	slPrint(toto,slLocate(19,5));	

}

int LoadFile(char *name, Uint8 *location, Uint32 size){
  //	Sint32 dirwork[SLCD_WORK_SIZE(MAX_FILE)];
  //	Sint32 ndir;
  CDHN cdhn;
  CDKEY key[2];
  CDBUF buf[2];
  Sint32 stat;
  Sint32 len[2];
  //  Sint32 CDerr;
  char toto[100];
  int last_state=99;
  // static int line=1;

  InitCD();

  //	ndir = slCdInit(MAX_FILE, dirwork);
  //	stat= slCdChgDir("0001");
  
  sprintf(toto,"->loadfile : %s",name);
  //  slPrint(toto,slLocate(1,line++));	

  key[0].cn = CDKEY_NONE;
  key[0].sm = CDKEY_NONE;
  key[0].ci = CDKEY_NONE;
  key[1].cn = CDKEY_TERM;

  cdhn = slCdOpen(name, key);
  
  if (cdhn!=NULL) {

    buf[0].type = CDBUF_COPY;
    buf[0].trans.copy.addr = location;
    buf[0].trans.copy.unit = CDBUF_FORM1;
    buf[0].trans.copy.size = size;
    buf[1].type = CDBUF_TERM;

    slCdLoadFile(cdhn, buf);

    while (1) {       // while read is not over
      slSynch();
      stat = slCdGetStatus(cdhn, len);
      
      switch (stat) {
      case CDSTAT_DOING : 
	sprintf(toto,"Read in progress   ");break;
      case CDSTAT_WAIT  : 
	sprintf(toto,"CD Waiting         ");break;
      case CDSTAT_PAUSE : 
	sprintf(toto,"CD Pause           ");break;
      case CDSTAT_COMPLETED : 
	sprintf(toto,"Completed          "); break;
      default :           
	sprintf(toto,"CD_stat inconnu    ");
      }
      //      if (stat!=last_state) slPrint(toto,slLocate(1,line++));	

      //  sprintf(toto,"CDERR_NEXIST %06d len[0] %d len[1] %d len[2] %d ",CDERR_NEXIST,len[0], len[1], len[2]);
      // slPrint(toto,slLocate(1,line++));	
      //sprintf(toto,"CDSTAT_DOING %06d",CDSTAT_DOING);	
      //      slPrint(toto,slLocate(1,line++));
      //      if (stat == CDSTAT_COMPLETED || stat == CDSTAT_WAIT || len[2]==0) break
  
      if ((stat == CDSTAT_COMPLETED)/*||(stat == CDSTAT_WAIT)*/) break;     
      last_state = stat;
    } 
    return 0;
  } else {
    sprintf(toto,"%02d %s          ", file_id, GFS_IdToName(2));
    //    slPrint(toto,slLocate(1,22));
    sprintf(toto,"file not found : %s               ",name);
    //    slPrint(toto,slLocate(15,23));	
    slSynch();
    return -1;
  }
}


void load_color_proms(char *name, unsigned short palette[]){
  int i;

  unsigned char buffer[513];

  if (LoadFile(name, &buffer[0x000], 1)==0)   {
    for(i=1;i<513;i+=2) {
      palette[(i-1)/2] = (buffer[i]>> 0) + (buffer[i-1] << 8);
    }
  }
}
