/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "sound.h"
#include "sgl.h"
#include "SEGA_SND.H"       // for SND_xxx functions
#include "sddrvs.dat"       // the sound driver

#define     SoundSeqBuf		0x25a0b000
extern char sound_map[];
extern char sound_dat[];
extern Uint32 mapsize;
extern Uint32 datsize;

void sound_init(){
  slInitSound(sddrvstsk , sizeof(sddrvstsk) , (Uint8 *)sound_map , mapsize) ;
  slDMACopy(sound_dat , (void *)(SoundSeqBuf) , datsize) ;
}

//void sound_play(Uint16 num,Uint8 prio, Uint8 vol, Uint8 Pan){
void sound_play(snd_type sfx){ 

  switch (sfx){
  case snd_lespin : 
    slSequenceOn((0 << 8) + 0,31,127,0);
    //    scrollTxtAddTxtLine("snd_lespin");
    break;
  case snd_birth : 
    slSequenceOn((0 << 8) + 1,31,127,0);
    //    scrollTxtAddTxtLine("snd_birth");
   break;
  case snd_death : 
    slSequenceOn((0 << 8) + 2,31,127,0);
    //    scrollTxtAddTxtLine("snd_death");
    break;
  case snd_good : 
    slSequenceOn((0 << 8) + 3,15,127,0);
    //    scrollTxtAddTxtLine("snd_good");
    break;
  case snd_bad : 
    slSequenceOn((0 << 8) + 4,15,127,0);
    //    scrollTxtAddTxtLine("snd_bad");
    break;
  case snd_bing : 
    slSequenceOn((0 << 8) + 5,1,127,0);
    //scrollTxtAddTxtLine("snd_bing");
    break;
    /*  case snd_accel : 
	slSequenceOn((0 << 8) + 6,0,127,0);
	// scrollTxtAddTxtLine("snd_accel");
	break;
    */
  default:
    break;
  }

}



void midize() {

  SND_ChgMap(0); /* change sound area map */
  SND_ChgMix(0,0); /* change mixer - default */
  SND_SetTlVl(15); /* max volume */

  /* change tone bank 0 select */
  SND_CtrlDirMidi(0x02, 0x00, /* sound control and priority number */
		  0x03,   /* MIDI command = control change */
		  0x01,  /* midi channel = 1 */
		  0x20,  /* data 1 = "tone bank change" */
		  0x00);  /* data 2 = tone bank number */

  /* Program change = 1 */

  SND_CtrlDirMidi(0x02, 0x00, /* sound control and priority number */
		  0x04,   /* MIDI command = program change */
		  0x01,  /* midi channel = 1 */
		  0x01,  /* data 1 = program change (voice) number */
		  0x00);  /* data 2 = not used = 0 */


  /* play a simple note */
  SND_CtrlDirMidi(0x02, 0x00, /* sound control and priority number */
		  0x01,  /* midi command = note on */
		  0x01,  /* midi channel = 1 */
		  60,    /* note value (pitch) = 60 */
		  127);  /* velocity = 127 */

}
